/*
 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************

 JuickPlugin
     Copyright (c) 2010 by Alexey Ryabov <6006l1k@gmail.com>
*/

#ifndef JPLUGIN_H
#define JPLUGIN_H

#include <qutim/plugininterface.h>
#include <QtGui>
#include <QDebug>

using namespace qutim_sdk_0_2;

class JuickPlugin : public QObject, SimplePluginInterface, EventHandler
{
    Q_OBJECT
	Q_INTERFACES(qutim_sdk_0_2::PluginInterface)
public:
	virtual bool init(PluginSystemInterface *plugin_system);
    virtual void release();
	virtual void processEvent(Event &event);
	virtual QWidget *settingsWidget();
	virtual void setProfileName(const QString &profile_name);
	virtual QString name();
	virtual QString description();
	virtual QString type();
	virtual QIcon *icon();
    virtual void removeSettingsWidget();
    virtual void saveSettings();
    virtual void loadSettings();
private:
	QIcon m_plugin_icon;
    PluginSystemInterface *m_plugin_system;
    QString m_profile_name;
    QString m_account_name;
	QWidget *m_settings_form;
	QCheckBox *m_button_user_bold;
	QCheckBox *m_button_user_italic;
	QCheckBox *m_button_user_underline;
	QCheckBox *m_button_msg_bold;
	QCheckBox *m_button_msg_italic;
	QCheckBox *m_button_msg_underline;
	QToolButton *m_button_user_color;
	QToolButton *m_button_msg_color;

	bool m_user_bold, m_user_italic, m_user_underline;
	bool m_msg_bold, m_msg_italic, m_msg_underline;
	QColor m_user_color, m_msg_color;

    quint16 m_event_msgin;
private slots:
    void chooseColor(QAbstractButton*); //copy-paste from juickplugin for psi+
};
#endif // JPLUGIN_H

