/*
    emoticonMenu

    Copyright (c) 2008 by Rustam Chakin <qutim.develop@gmail.com>
				  2009 by Ruslan Nigmatullin <euroelessar@gmail.com>

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************
*/


#ifndef CHATEMOTICONBAR_H
#define CHATEMOTICONBAR_H

#include <QtGui>
#include <QTimer>
#include <cmath>
#include "movielabel.h"

class ChatEmoticonBar : public QScrollArea
{
    Q_OBJECT

public:
        ChatEmoticonBar(QWidget *parent = 0);
    ~ChatEmoticonBar();
	void setEmoticons(QHash<QString, QStringList>);
        void setAutoclose(bool autoclose,int time);
public slots:
	void ensureGeometry();
        void resetTimer();
signals:
        void insertSmile(const QString &);
        void m_hide();
protected:

	void hideEvent ( QHideEvent * );
	void showEvent ( QShowEvent * );
        void wheelEvent(QWheelEvent *e);
    
private:
	QList<QSize> sizeList;
    QList<movieLabel *> labelList;
    QList<QMovie *> movieList;
	QHash<QString, QString>  _emotList;
    QVBoxLayout *m_grid_layout;
	QWidget *m_widget;
	QSize m_desktop_geometry;
        QTimer *timer;
        bool m_autoclose;
        int m_emoclosetime;
	void clearList();
};

#endif // CHATEMOTICONBAR_H
