/*
    movieLabel

    Copyright (c) 2008 by Rustam Chakin <qutim.develop@gmail.com>

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************
*/


#include "movielabel.h"



movieLabel::movieLabel(QWidget *parent) : QLabel(parent)
{
        pressed=false;
}

movieLabel::~movieLabel()
{
	
}

void movieLabel::mousePressEvent( QMouseEvent * event )
{
   pressed=true;
   QLabel::mousePressEvent(event);
}

void movieLabel::setInsOnUp(bool insonup)
{
    m_insonup=insonup;
}

void movieLabel::mouseReleaseEvent( QMouseEvent * event )
{
    if(pressed || m_insonup)
    {
        QPoint mvpnt=event->pos();
        QSize mvsz=this->size();
        if(mvpnt.x()<mvsz.width() && mvpnt.x()>0 && mvpnt.y()<mvsz.height() && mvpnt.y()>0)
        emit sendMovieTip(toolTip());
    }
    pressed=false;

    setFrameStyle(QFrame::NoFrame);
    QLabel::mousePressEvent(event);
}

void movieLabel::enterEvent( QEvent * event )
{
    setFrameStyle(QFrame::StyledPanel | QFrame::Plain);
    setLineWidth(2);
    QLabel::enterEvent(event);
}

void movieLabel::leaveEvent( QEvent * event )
{
    setFrameStyle(QFrame::NoFrame);
    QLabel::leaveEvent(event);
}
